





	; 
	; IDIOT/4 MONITOR FOR THE 1802 WRITTEN: 6/23/82 BY LEE HART ;
	; COPYRIGHT 1982-85 BY TMSI LAST MOD: 3/28/86 BY LEE HART ;
	; ;
	; This program may be used for any noncommercial use free of ;
	; charge. Contact information: Lee A. Hart, 814 8th Ave N, ;
	; Sartell MN 56377, email <leeahart@earthlink.net> ;
	; -------------------------------------------------------------	; 
	; 
	; fixes by Herb Johnson HRJ April 2010, Jan 2014
	; changed "DC" to "DB" -CAM: TRANSLATED TO RCA CRA LEVEL I SYNTAX.
	; 
	; CAM:RE-ORG'ed TO 0000h.
	; 
	; changed other ORG [value] to RESET+ [value] -RETAINED.
	; 
	; OUT 7 "turn reader on" bit 7 "off" bit 6 CAM: -DEPRECATED.
	; READER CONTROL REMOVED TO CONSERVE I/O's
	; 
	; This version of IDIOT has been modified to use the RCA CDP1854 UART
	; for serial I/O; and to use 2-level I/O grouping. All values for this are symbolized
	; in the code so the user can configure the I/O group and the UART register addressing
	; by changing the equate values in the I/O equates below.
	; 
	; ORG statements have been inserted to "space out" the code where passages were deleted,
	; so the original code will stay at its original addresses. These ORG addresses are coded as 
	; offsets from RESET so the program can be relocated by changing the ORG = 0000h at the
	; beginning. The program remains object-relocatable.
	; 
	; register equivalents for A18
	; 0 = 0
	; 1 = 1
	; 2 = 2
	; 3 = 3
	; 4 = 4
	; 5 = 5
	; 6 = 6
	; 7 = 7
	; 8 = 8
	; 9 = 9
	; A = 10
	; B = 11
	; C = 12
	; D = 13
	; E = 14
	; F = 15
	; 
	; 
	; REGISTER ASSIGNMENTS:
	; 
	; 1 - INTERRUPT PROGRAM COUNTER (FOR BREAKPOINTS)
	; 2 - STACK POINTER
	; 3 - NORMAL PROGRAM COUNTER
	; 4 - MONITOR: RAM PAGE0 POINTER
	;     BASIC: SCRT "CALL" PC
	; 5 - MONITOR: MAIN PC
	;     BASIC: SCRT "RETURN" PC
	; 8 - MONITOR: ?M VS. !M SWITCH
	;10 - MONITOR: MEMORY POINTER
	; 
	; EQUATES
	; 
u8N1	EQU	19h	    ; UART control word for 8bits no parity 1 stopbit
;u7N1	EQU	13h         ; UART CONTROL WORD FOR 7BITS NO PARITY 1 STOPBIT
TYPA	EQU	0D3h
	; 
	; I/O
	; 
UCTRL	EQU	03h 	; UART CTRL/STATUS REGISTER
UDATA	EQU	02h 	; UART DATA REGISTER
;GSEL	EQU	07h 	; SYSTEM I/O GROUP SELECT REGISTER (ADDED HARDWARE)
;UGRP	EQU	01h 	; I/O GROUP CONTAINING THE UART
	; 
	; REGISTERS
	; 
SP	EQU	02h
DELAY	EQU	0Ch 	; PC FOR DELAY SUBROUTINE
HEXX	EQU	0Dh 	; MONITOR: HEX ADDRESS ACCUMULATOR
BAUD	EQU	0Eh 	; RE.1=BAUD RATE CONSTANT
	; RE.0=USED FOR READ, TYPE
ASCII	EQU	0Fh 	; RF.1=ASCII I/O CHARACTER
	; RF.0=USED FOR READ, TYPE
	; 
	; 
	ORG	0C00h
	; 
	; 
	; HRJ for Membership Card
RESET:     DIS   	;   DISABLE INTERRUPTS
           DB	0h
;	   OUT GSEL
;	   DB  UGRP 	; SETUP I/O GROUP
           OUT UCTRL
	   DB	u8N1 	; 8 bits data, no parity, 1 stopbit
;	   DB	u8N1 	; 7 BITS DATA, NO PARITY, 1 STOPBIT
FINDRAM:   LDI 0FFh  	;   FIND RAM, STARTING AT FFFF
           PHI 4
TRYAGAIN:  LDI 0FFh  	;   REPEAT	; .
           PLO 4 	; -TEST TOP BYTE ON PAGE
           STR 4 	; -STORE 'FF'
           LDN 4 	; READ IT BACK,
           XRI 0FFh 	; COMPARE
           LSNZ 	; -IF OK, STORE ALL 0'S,
           STR 4 	; READ BACK,
           LDN 4 	; COMPARE
           BZ RAMFOUND 	; -IF OK, THEN RAM FOUND
           GHI 4 	; -IF NO MORE PAGES TO TEST,
           BZ NORAM 	; THEN GO TO NORAM
           PLO 4 	; ELSE DEC. PAGE NUMBER
           DEC 4
           GLO 4
           PHI 4 	; UNTIL DONE
           BR TRYAGAIN
RAMFOUND:  LDI 0DFh  	;   RAM FOUND:
           PLO 4 	; SAVE CPU REGISTERS
           SEX 4
	; 
	; 
	; SAVE REGISTERS: SAVES A COPY OF ALL CPU REGISTERS & I/O BITS
	; IN RAM. MUST BE ENTERED WITH P=R0 OR R1, X=R4. SAVES
	; ALL REGISTERS CORRECTLY EXCEPT P, X, D, R(P), AND R4.
	; 
	; 
SAVER:     GLO 0Fh  	;   SAVE REGISTERS R0-RF IN RAM
           STXD
           GHI 0Fh 	; RF 1ST, R0 LAST,
           STXD 	; WITH HI BYTE IN LOWER ADDRESS
           GLO 0Eh
           STXD
           GHI 0Eh
           STXD 	; THE REGISTERS BEING USED FOR PROGRAM
           GLO 0Dh 	; COUNTER AND RAM POINTER ARE CHANGING
           STXD 	; DURING EXECUTION, SO THEIR STORED VALUES
           GHI 0Dh 	; WILL BE FIXED LATER.
           STXD
           GLO 0Ch
           STXD
           GHI 0Ch
           STXD
           GLO 0Bh
           STXD
           GHI 0Bh
           STXD
           GLO 0Ah
           STXD
           GHI 0Ah
           STXD
           GLO 9
           STXD
           GHI 9
           STXD
           GLO 8
           STXD
           GHI 8
           STXD
           GLO 7
           STXD
           GHI 7
           STXD
           GLO 6
           STXD
           GHI 6
           STXD
           GLO 5
           STXD
           GHI 5
           STXD
           STXD 	; DON'T BOTHER TO SAVE R4 (SAVES 2 BYTES)
           STXD
           GLO 3
           STXD
           GHI 3
           STXD
           GLO 2
           STXD
           GHI 2
           STXD
           GLO 1
           STXD
           GHI 1
           STXD
           GLO 0
           STXD
           GHI 0
           STXD
           LDI 0 	; LOAD 0 (& SAVE A COPY FOR LATER)
           PHI 3
           BN4 ($+4) 	; PACK STATUS OF EF4 & EF3 INTO 1 BYTE
           ORI 04h 	; AND PUSH INTO RAM
           BN3 ($+4) 	; X4 -EF4 ACTIVE
           ORI 30h 	; 3X -EF3 ACTIVE
           STXD
           GHI 3 	; PACK STATUS OF EF2 & EF1 INTO 1 BYTE
           BN2 ($+4) 	; AND PUSH INTO RAM
           ORI 02h 	; X2 -EF2 ACTIVE
           BN1 ($+4) 	; 1X -EF1 ACTIVE
           ORI 10h
           STXD
           GHI 3 	; PUSH STATUS OF Q INTO RAM
           LSNQ 	; 1 -Q ACTIVE
           ORI 1 	; 0 -Q INACTIVE
           STXD
           LDI 1 	; PUSH STATUS OF IE INTO RAM
           LSIE 	; 1 -ENABLED
           LDI 0 	; 0 -DISABLED
           STXD
           GHI 3 	; PUSH D(=0) TO RAM (DUMMY VALUE)
           STXD
           ADCI 0 	; PUSH DF INTO RAM
           STXD
           SAV 	; PUSH T INTO RAM
           DEC 4
           LDI LOW(IFINT) 	; IF CALLED VIA INTERRUPT, RETURN
           PLO 1
           GHI 0 	; ELSE CALLED VIA RESET,
           PHI 1 	; SET RP=R1
           LDI LOW($+4)
           PLO 1
           SEP 1
           LDI 0 	; PUSH STATUS=0
           STR 4
	; 
	; 
CONTINIT:  LDI  LOW(CHANGE) 	;   COPY CODE THAT CHANGES TO THE DESIRED PC
           PLO 5 	; FOR A $R COMMAND. THE CODE GOES TO 35 BYTES
           GHI 1 	; BEFORE "SAVEREG" MEMORY
           ADI 3
           PHI 5
           LDI 0A0h
           PLO 4
           LDI 24
           PLO 3
INITLOOP:  LDA 5  	;   LOOP AND MOVE THE BYTES
           STR 4
           INC 4
           DEC 3 	; R4 WILL END UP POINTING TO XXB8
           GLO 3
           BNZ INITLOOP
           GHI 4 	; INITIALIZE R2 (STACK POINTER)
           PHI 2
           LDI 0C3h 	; CORRECT STORED VALUE OF R1
           PLO 4
           LDI LOW(INTERUPT)
           STXD
           GHI 1
           STXD
           GHI 1 	; LOAD R5 WITH ADDRESS OF "ENTRY"
           ADI 1
           PHI 5
           LDI LOW(ENTRY)
           PLO 5
           LDI 0FEh 	; POINT R3 TO TIMALC
           PLO 3
           GHI 1
           PHI 3 	; CALL TIMALC; IT RETURNS WITH "SEP R5", -- DEPRECATED 	; SO IT WILL RETURN TO "ENTRY"
           SEP 5
	; NOTE: DELAY AND TIMALC DELETED AS WE 
	; ARE USUNG A UART. THUS WE SEP 5 NOW TO GO
	; DIRECTLY TO MONITOR. 
	; 
	; 
	; INTERUPT: INTERRUPT HANDLER FOR IDIOT MONITOR. HARDWARE INTERRUPT
	; SAVES ALL REGISTERS EXCEPT T CORRECTLY. A SOFTWARE INTERRUPT
	; (D1=SEP R1) SAVES ALL BUT P AND X CORRECTLY. R2 MUST POINT TO
	; A STACK WITH AT LEAST 4 FREE BYTES TO SAVE D AND R4 CORRECTLY.
	; 
	; 
INTERUPT:  SEX 2  	;   ENTRY: OLD P AND X DESTROYED
           DEC 2 	; DEC. STACK POINTER TO FREE LOCATION
           STXD 	; PUSH D
           GHI 4 	; PUSH R4
           STXD
           GLO 4
           STR 2
           SEX 4 	; SET X=R4 AND GO TO SAVE REGISTERS
           BR FINDRAM
IFINT:     LDI 10h  	;   RETURN ERE:
           STXD 	; PUSH STATUS=10
           LDI 0C9h 	; CORRECT STORED CONTENTS OF R4
           PLO 4
           LDA 2
           STXD
           LDA 2
           STXD
           LDI 0BBh 	; CORRECT STORED CONTENTS OF D
           PLO 4
           LDA 2
           STR 4
           LDI 0C5h 	; CORRECT STORED VALUE OF STACK POINTER
           PLO 4 	; TO ACTUAL VALUE AT TIME OF INTERRUPT
           GLO 2
           STXD
           GHI 2
           STXD
           BR CONTINIT 	; GO CONTINUE INITIALIZATION
	; 
	; 
NORAM:     GHI 0  	;   NO RAM:     CAN'T SAVE REGISTERS
           ADI 1
           PHI 3
           LDI LOW(ENTRY) 	; CHANGE PROGRAM COUNTER TO R3
           PLO 3
           SEX 2 	; STACK POINTER TO R2
           SEP 3 	; GO TO IDIOT/2
	; 
	; 
	; READ: READS A SERIAL CHARACTER VIA EF4 AND RETURNS WITH ITS ASCII CODE IN
	; ASCII.1 AND D (BUT D WILL BE LOST IF SCRT CALL & RETURN IS USED).
	; EXPECTS P=3; ALTERS DF, ASCII, & BAUD.0; AND RETURNS WITH SEP R5. 
	; 
	; TTYRED: SAME AS "READ", BUT FIRST DOES AN "OUT 7" X'80' TO TURN ON 
	; A SERIAL INPUT DEVICE SUCH AS A TAPE RECORDER. ONCE A CHARACTER HAS
	; STARTED, AN "OUT 7" X'40' IS USED TO TURN IT OFF AGAIN.
	; 
	; READAH: SAME AS "READ", BUT IF A HEX CHARACTER (0-9, A-F), IT IS ALSO 
	; SHIFTED INTO THE LOW 4 BITS OF "HEXX" & DF=1 IS RETURNED; IF NOT
	; HEX, RETURNS DF=0, "READAH" USES P=R3, ALTERS D, DF, RF, RE.0, &
	; RETURNS WITH A "SEP R5" AND R3 POINTING TO "READAH" ENTRY POINT.
	; 
	; NOTE: THE READ ROUTINES EXIT AT THE BEGINNING OF THE ECHOED STOP BIT,
	; & SET BAUD.0 (RE.0) >0 AS A DELAY FLAG FOR THE "TYPE" ROUTINES. THE
	; "TYPE" ROUTINES CHECK THIS FLAG BEFORE TYPING THE NEXT BYTE, & IF
	; SET, WILL FIRST SEND 2 STOP BITS. TAKE CARE NOT TO RESET THIS FLAG 
	; (BY USING THE DELAY ROUTINE OR RE.0) UNTIL ENOUGH TIME HAS PASSED
	; SO NO FURTHER DELAY IS NEEDED.
	; 
	; 
           ORG	(RESET+12Fh) 	; HRJ offset
CKDEC:     ADI 7  	;   IF CHARACTER IS 0-9 OR A-F,
           BDF NFND
           ADI 0Ah 	; THEN SHIFT IT IN
           BDF FND 	; ELSE IS NON-HEX,
NFND:      ADI 0  	;   SET DF=0
REXIT:     GHI ASCII  	;   PUT CHARACTER IN D
           SEP 5 	; RETURN WITH ENTRY FLAG SET:
READAH:    LDI 80h  	;     =80 IF VIA READA
           SKP
READ:      GLO 3  	;     =3F IF VIA READ
           LSKP
TTYRED:    LDI 0h  	;     =00 IF VIA TTYRED
           PLO ASCII 	; SAVE ENTRY FLAG
READ2:     LDI 80h  	;   SET #BITS IN CHARACTER=7
           PHI ASCII 	; (TAKES 7 SHIFTS TO CHANGE '80' INTO '01')
           SEX 3
           GLO ASCII 	; GET ENTRY FLAG
	; LSNZ	; IF TTYRED,
	; OUT 7	; TURN READER ON
	; ,80h
	; 
	; UART INPUT CODE HERE
	; 
           SEX SP
KEY1:      INP UCTRL       	;  GET DA BIT FROM
           SHR 	; UART STATUS BYTE
           BNF KEY1 	; WAIT 'TILL DATA AVAIL.
	; 
           INC SP
           INP UDATA 	; GET DATA
           STR SP
           OUT UDATA 	; ECHO
           DEC SP
           PHI ASCII
           DEC SP
           BR BZ

           ORG	(RESET + 179h) 	; CONTINUATION OF ORIGINAL CODE
	; 
BZ:        BZ READ2  	;   REPEAT IF 00=NULL
           GLO ASCII 	; IF READ OR TTYRED,
           SHL 	; THEN GO TO EXIT
           BNF REXIT 	; ELSE IS READAH:
           GHI ASCII 	; IF CHARACTER < "A",
           SMI 41h 	; TEN GO CECK FOR A NUMBER (0-9)
           BNF CKDEC
           SMI 06h 	; ELSE CECK FOR LETTERS A-F
           BDF NFND
FND:       SHL   	;   CHARACTER IS HEX:
           SHL
           SHL 	; SHIFT IT INTO THE LOWEST 4 BITS OF HEXX,
           SHL 	; 1 BIT AT A TIME
           ADI 8
           SHL
FND1:      PLO BAUD  	;   REPEAT FOUR TIMES	; .
           GLO HEXX 	; -SHIFT BIT INTO HEXX.0
           SHLC
           PLO HEXX
           GHI HEXX 	; -SHIFT CARRY BIT INTO HEXX.1
           SHLC
           PHI HEXX
           GLO BAUD 	; -GET NEXT BIT
           SHL 	; 	; .UNTIL DONE
           BNZ FND1
           BR REXIT 	; EXIT WITH DELAY FLAG SET
	; 
	; 
	; TYPE5: TYPES THE BYTE AT THE MEMORY LOCATION POINTED TO BY R5, & THEN
	; INCREMENTS R5. IF DELAY FLAG IS SET (BAUD.0>1), "TYPE5" 1ST WAITS
	; 2 BIT-TIMES SO ANY PREVIOUS READ OPERATIONS END, TYPES THE BYTE,
	; AND THEN RESETS THE DELAY FLAG=0 SO FURTHER TYPES ARE NOT DELAYED.
	; 
	; TYPE6: SAME, BUT USES & INCREMENTS R6.
	; 
	; TYPE: SAME, BUT TYPES ASCII.1 (RF.1) 
	; 
	; TYPE5D: SAME AS "TYPE5", BUT ALWAYS WAITS 2 BIT-TIMES.
	; 
	; TYPE2: SAME AS "TYPE5", BUT TYPES THE CONTENTS OF ASCII.1 (RF.1)
	; AS TWO HEX DIGITS (0-9, A-F).
	; 
	; ALL TYPE ROUTINES USE P=R3, EXIT VIA "SEP R5", & CAN USE THE SCRT 
	; CALL & RETURN. THE SERIAL OUTPUT USES "Q",WITH 1 START, 8 DATA, & 
	; 2 STOP BITS. LINE FEEDS <LF> ARE FOLLOWED BY 3 NULLS (=0) IN CASE 
	; THE TERMINAL NEEDS TIME FOR THE <CR><LF> SEQUENCE. Q=0 IS "MARK"
	; OR STOP BIT; Q=1 IS A "SPACE" OR START BIT. THE DELAY ROUTINE
	; DETERMINES THE BAUD RATE. ALL "TYPE" ROUTINES ALTER D,DF,X,RD.0,
	; RE.0, RF.0, & EXIT WITH R3 AT "TYPE5". 
	; 
	; BAUD.0 = DELAY FLAG: =0 NO DELAY
	; >0 DELAY 2 BITS
	; ASCII.0 = (LO 4 BITS) #BITS/CHARACTER
	; = (HI 4 BITS) 0= BYTE OUTPUT 
	; 1= 1ST HEX OUT 
	; 2= LAST HEX OUT
	; 5= <LF> OUTPUT 
	; 
           ORG	(RESET+19Ch) 	; HRJ reset
TYPE5D:    GHI BAUD  	;   IF TYPE5D,
           PLO BAUD 	; THEN SET DELAY FLAG TRUE (>0)
           SKP
TYPEXIT:   SEP 5
TYPE5:     LDA 5  	;   IF TYPE5, GET BYTE VIA R5, THEN INC. R5
           SKP
TYPE6:     LDA 6  	;   IF TYPE6, GET BYTE VIA R6, THEN INC. R6
           SKP
TYPE:      GHI ASCII  	;   IF TYPE, GET BYTE IN ASCII.1
           PLO 0Dh
	; 
	; 
	; DETERMINE CODE BYTE
	; 
	; 
           XRI 0Ah 	; IF LINE FEED,
           BNZ TY2 	; THEN SET CODE=<LF>, 11 BITS
           LDI 5Bh
           BR TY3
TYPE2:     GHI ASCII  	;   IF TYPE2,
           SHR 	; THEN GET ASCII.1
           SHR 	; EXTRACT UPPER 4 BITS
           SHR
           SHR
           ADI 0F6h 	; CONVERT TO HEX:
           LSNF 	; IF "A" OR MORE, ADD 37
           ADI 7
           SMI 0C6h 	; ELSE ADD 30
           PLO 0Dh
           LDI 1Bh 	; CODE=HEX, 11 BITS
           LSKP
TY2:       LDI 0Bh  	;     ELSE SET CODE=BYTE, 11 BITS
TY3:       PLO ASCII  	;   SAVE CODE BYTE

	; 
	; BEGIN SERIAL OUTPUT (DELAY + 44 MACHINE CYCLES PER LOOP)
	; NO DELAY ANYMORE, THE CODE BELOW DRIVES THE UART.
	; 

BEGIN2:    SEX SP
           INP UCTRL 	; Check UART ready.
           SHL
           BNF BEGIN2
	; 
OUTPUT:    INC SP
           GLO 0Dh
           STR SP
           OUT UDATA 	; Send character from stack.
           DEC SP
           DEC SP
           GLO ASCII
           SMI 0Bh
           PLO ASCII
           BR NXCHAR
	; 
           ORG	(RESET + 01DDh) 	; CONTINUATION OF ORIGINAL CODE
	; 
NXCHAR:    GLO ASCII  	;   GET CODE BYTE;
           ADI 0FBh 	; DECREMENT CODE,
           PLO ASCII 	; SET #BITS=11
           BNF TYPEXIT 	; IF NO MORE, EXIT!
	; 
	; 
	; TEST CODE BYTE TO SEE WHAT TO DO NEXT.
	; 
	; 
           SMI 1Bh 	; IF CODE=1,
           BZ TYPEXIT 	; THEN WAS LAST NULL: EXIT
           LDI 0 	; IF CODE>1,
           BDF HX22 	; THEN GET NULL & GO TYPE IT
	;	; IF CODE=0,
HEX2:      GHI ASCII  	;      GET BYTE
           ANI 0Fh 	; MASK LOWER 4
           ADI 0F6h 	; CONVERT TO EX
           LSNF 	; IF "A" OR MORE,
           ADI 7 	; THEN ADD 37
           SMI 0C6h 	; ELSE ADD 30
HX22:      PLO 0Dh  	;      LOAD BYTE
           BR BEGIN2 	; BEGIN TYPING IT

	; 
	; "IDIOT" MONITOR: UTILITY PROGRAM TO EXAMINE & CHANGE REGISTERS OR MEMORY,
	; AND EXECUTE PROGRAMS WITH BREAKPOINTS. AN ASTERISK (*) INDICATES
	; "IDIOT" IS READY FOR A COMMAND. ALL COMMANDS CONSIST OF PUNCTUATION
	; (?!*) FOLLOWED BY A LETTER (M,P,R). ALL OTHER INPUTS ARE IGNORED.
	; NUMBERS ARE HEXADECIMAL, AND LEADING ZEROS ARE UNNECESSARY. SPACES,
	; LINE FEEDS, & CARRIAGE RETURNS CAN BE USED BETWEEN NUMBERS FOR
	; READABILITY. THE COMMANDS ARE:
	; 
	; !M - CHANGE MEMORY
	; EXAMPLE: !MA00 11 22 33 <CR>
	; WRITES HEX BYTES (11,22,33) INTO MEMORY, STARTING AT THE SPECIFIED
	; ADDRESS (0A00).
	; 
	; ?M - EXAMINE MEMORY
	; EXAMPLE: ?MA00 3 <CR>
	; TYPES: 0A00 1122 33 <CR>
	; TYPE THE SPECIFIED ADDRESS (0A00) AND THE CONTENTS OF THE SPECIFIED
	; NUMBER OF BYTES OF MEMORY (3). LONG LISTINGS CAN BE ABORTED BY
	; TYPING A "BREAK".
	; 
	; - MOVE MEMORY
	; EXAMPLE: ?MA00 3 !M800 <CR>
	; MOVES A SPECIFIED NUMBER OF BYTES IN MEMORY (3) FROM ONE ADDRESS
	; (0A00) TO ANOTHER (0800). THE BLOCKS CAN OVERLAP WITHOUT ERROR.
	; 
	; ?R - EXAMINE CPU REGISTERS
	; EXAMPLE: ?R <CR>
	; TYPES: 10B8 ID T DF D IE Q EF1234
	; 10C0 R0 R1 R2 R3 R4 R5 R6 R7
	; 10D0 R8 R9 RA RB RC RD RE RF
	; TYPES CONTENTS OF CPU REGISTERS SAVED AFTER THE LAST INTERRUPT,
	; BREAKPOINT, OR RESET. "10B8" ETC. IS THE ADDRESS IN RAM WHERE THIS 
	; DATA IS STORED. REGISTER CONTENTS CAN BE CHANGED WITH A !M COMMAND,
	; AND RESTORED WITH A *R COMMAND.
	; 
	; $P - RUN PROGRAM
	; EXAMPLE: $PA00 <CR>
	; BEGINS PROGRAM EXECUTION AT THE ADDRESS SPECIFIED (0A00) WITH
	; P=X=R0 AND INTERRUPTS ENABLED.
	; 
	; $R - RUN REGISTERS
	; EXAMPLE: $R23 <CR>
	; BEGINS PROGRAM EXECUTION WITH THE CPU REGISTERS SET TO THE CONTENTS
	; OF RAM LOCATIONS 10BA-10EF, AND X & P SET TO THE SPECIFIED VALUES
	; (X=2, P=3).
	; 
ENTRY:     GHI 5  	;   SET A POINTER TO TYPE5D
           PHI 3
           LDI LOW(TYPE5D)
           PLO 3 	; TYPE "SIGNON" MESSAGE:
           DB	LOW(TYPA) ,13 	; <CR>
           DB	LOW(TYPA) ,10 	; <LF>
           DB	LOW(TYPA) ,'I' 	; <I>
           DB	LOW(TYPA) ,'D' 	; <D>
           DB	LOW(TYPA) ,'I' 	; <I>
           DB	LOW(TYPA) ,'O' 	; <O>
           DB	LOW(TYPA) ,'T' 	; <T>
           DB	LOW(TYPA) ,'/' 	; </>
           DB	LOW(TYPA) ,'4' 	; <4>
RESTART:   GHI 5
           SMI 1
           PHI 3
           LDI LOW(TYPE5D)
           PLO 3 	; TYPE "PROMPT" MESSAGE:
           DB	LOW(TYPA) ,13 	; <CR>
           DB	LOW(TYPA) ,10 	; <LF>
           DB	LOW(TYPA) ,'*' 	; <*>
IGNORE:    LDI 0
           PHI HEXX 	; SET HEXX=0
           PLO HEXX
           LDI LOW(READAH) 	; REPEAT	; .
           PLO 3
           SEP 3 	; -GET A KEY
           XRI '$' 	; -IF "$"
           BZ DOLLAR 	; GO TO DOLLAR
           XRI 05h 	; -IF "!",
           PLO 8 	; SET SWITCH=0
           LSZ 	; -IF "?",
           XRI 1Eh 	; LEAVE SWITCH>0
           BNZ IGNORE 	; 	; .UNTIL ONE FOUND

	;
	; GET ADDRESS FOR ?M, !M, OR ?R COMMAND 
	;
           SEP 3 	; GET NEXT KEY
           XRI 'R' 	; IF "R",
           BNZ RDARGS
           LDI 0B8h 	; SET ADDRESS TO SAVED REGISTERS
           PLO 0Ah
           GHI 2
           PHI 0Ah
           LDI 40 	; SET #BYTES=40
           PLO HEXX
           SEP 3 	; GET NEXT KEY
           BR RD3 	; GO TYPE IT
RDARGS:    XRI 1Fh  	;   IF "M",
           BNZ IGNORE
RD1:       SEP 3  	;      IGNORE LEADING NON-HEX CHARACTERS
           BNF ($-1)
           SEP 3 	; ASSEMBLE HEX CHAR.INTO ADDRESS
           BDF ($-1)
           XRI 20h 	; IF NEXT KEY NOT "SPACE",
           BNZ SYNERR 	; GO TO SYNTAX ERROR
           GHI HEXX
           PHI 0Ah 	; LET ADDRESS POINTER=HEXX
           GLO HEXX
           PLO 0Ah 	; IF SWITCH=0,
           GLO 8 	; IS "!M" COMMAND;
           BZ EX1 	; GO TO EX1
	; 
	; 
	; ?M COMMAND: GET #BYTES TO TYPE
	; 
	; 
           LDI 0 	; SET HEXX=0
           PLO HEXX
           PHI HEXX
RD2:       SEP 3  	;   GET KEYS & ASSEMBLE INTO HEX
           BDF ($-1)
	; 
	; DETERMINE IF TYPE OR MOVE COMMAND
	; 
RD3:       GLO HEXX  	;   SET #BYTES=HEXX
           PLO 8
           GHI HEXX
           PHI 8
           GHI ASCII 	; GET LAST KEY
RD5:       XRI '!'  	;   IF "!",
           BZ BRMOVE 	; GO TO MOVE DATA
           XRI 01h 	; IF "SPACE",
           BNZ ($+5) 	; IGNORE IT,
           SEP 3 	; GET ANOTHER KEY
           BR RD5 	; REPEAT
           XRI 2Dh 	; IF <CR>, GO TO TYPE
           BNZ SYNERR 	; ELSE SYNTAX ERROR
	; 
	; 
	; TYPE SPECIFIED DATA.
	; 
	; 
RD4:       LDI  LOW(TYPE5D)
           PLO 3
NXLINE:    SEP 3  	;   TYPE <LF>
           DB	0Ah
	; 
           B3 SYNERR 	; BREAK IF /EF3 IS BROUGHT LO
	; 
LINE1:     GHI 0Ah  	;   TYPE ADDRESS OF POINTER:
           PHI ASCII
           LDI LOW(TYPE2)
           PLO 3
           SEP 3 	; UPPER BYTE
           GLO 0Ah
           PHI ASCII
           LDI LOW(TYPE2)
           PLO 3
           SEP 3 	; LOWER BYTE
           SEP 3 	; TYPE A "SPACE"
           DB	20h
TLOOP:     LDA 0Ah  	;   GET BYTE @ POINTER, & ADVANCE POINTER
           PHI ASCII
           LDI LOW(TYPE2) 	; TYPE BYTE
           PLO 3
           SEP 3
           DEC 8 	; DECREMENT #BYTES
           GLO 8
           BNZ TL3 	; IF #BYTES=0,
           GHI 8 	; GO TO RESTART
           BZ RESTART
TL3:       GLO 0Ah  	;   IF LINE IS FULL (I.E. ADDRESS ENDS IN XXX0),
           ANI 0Fh
           BNZ TL2
           SEP 3 	; TYPE <;>
           DB	';'
           SEP 3 	; TYPE <CR>
           DB	0Dh
           BR NXLINE 	; GO TO NEXT LINE
TL2:       SHR   	;   IF ODD ADDRESS,
           BDF TLOOP 	; THEN TYPE NEXT BYTE
           BR (TLOOP-2) 	; ELSE GO TYPE A "SPACE" FIRST
	; 
	; 
	; !M COMMAND: WRITES BYTES INTO MEMORY
	; 
	; 
EX3:       SEP 3  	;   GET KEYS UNTIL HEX
           BNF ($-1)
EX2:       SEP 3  	;   GET 2ND HEX KEY
           BNF SYNERR 	; IF NOT HEX, SYNTAX ERROR
           GLO HEXX 	; STORE BYTE AT ADDRESS,
           STR 0Ah 	; INCREMENT ADDRESS
           INC 0Ah
EX1:       SEP 3  	;   GET NEXT KEY
           BDF EX2 	; IF HEX, ASSEMBLE INTO ADDRESS AND REPEAT
           XRI 0Dh 	; IF <CR>,
           BZ RESTART 	; DONE: GO TO RESTART
EX4:       XRI 21h  	;   IF <,>,
           BZ EX3 	; CONTINUE ON NEW LINE
           XRI 17h 	; IF <;>, CONTINUE
           BNZ EX1 	; ELSE IGNORE KEY & REPEAT
           SEP 3 	; IF <:>,
           XRI 0Dh 	; IGNORE FURTER KEYS UNTIL <CR>
           BNZ ($-3)
           BR RD1 	; THEN CONTINUE ON NEW LINE WITH A NEW ADDRESS.
	; 
	; 
	; SYNTAX ERROR
	; 
	; 
SYNERR:    LDI  LOW(TYPE5D) 	;   POINT TO TYPE5D
           PLO 3
           SEP 3 	; TYPE <CR>
           DB	0Dh
           SEP 3 	; <LF>
           DB	0Ah
           SEP 3 	; <?>
           DB	'?'
           BR RESTART 	; AND RESTART.
	; 
	; 
	; *P AND *R COMMANDS
	; 
	; 
DOLLAR:    SEP 3  	;   GET KEY
           XRI 'R' 	; IF "R",
           PLO 8 	; SET SWITCH=0
           LSZ 	; IF "P",
           XRI 02h 	; LEAVE SWITC>0
           BNZ IGNORE 	; IGNORE ALL ELSE.
	; 
	; 
	; GET NUMBER FOR $R OR $P COMMAND
	; 
	; 
D1:        SEP 3  	;   GET NEXT KEY
           BDF ($-1) 	; IF HEX, ASSEMBLE ADDRESS & REPEAT
           XRI 0Dh 	; IF NOT <CR>,
           BNZ SYNERR 	; GO TO SYNTAX ERROR
           GHI HEXX 	; PUT NUMBER IN R0
           PHI 0
           GLO HEXX
           PLO 0
           LDI LOW(TYPE5D) 	; TYPE <LF>
           PLO 3
           SEP 3
           DB	0Ah
           GLO 8 	; IF SWITCH>0,
           BZ RESTORE 	; IS "*P" COMMAND; CONTINUE.
	; 
	; 
	; $P COMMAND: BEGIN EXECUTION AT SPECIFIED ADDRESS WITH P=X=0, IE=1
	; 
	; 
           LDI LOW(INTERUPT) 	; SET R1 FOR BREAKPOINT INTERRUPT
           PLO 1
           GHI 5
           SMI 2
           PHI 1
           SEX 5 	; EXECUTE AT ADDRESS IN R0!
           RET
           DB	0h
           BR (RESET+2FFh) 	; BRANCH OVER PAGE JUMPS HRJ add offset
           ORG	(RESET+2F4h) 	; PAGE JUMPS: ALLOW RELOCATABLE BRANCH TO PAGE 3
           BR SYNERR
           NOP
           NOP
           BR RESTART
BRMOVE:    GHI 5  	;   GO TO "MOVE" JUMP ON PAGE 3
           ADI 1
           PHI 5
	; 
	; 
	; $R COMMAND: RESTORE ALL CPU REGISTERS (EXCEPT "T") TO THE VALUES SAVED.
	; IN RAM, & EXECUTE WITH THE SPECIFIED VALUES OF X AND P.
	; 
	; NOTE: REGISTER NAMES IN PARENTHESES INDICATE THE VALUE IN RAM TO
	; BE RESTORED TO THAT REGISTER.
	; 
	; 
RESTORE:   GHI 2  	;   R2=POINTER TO RAM WHERE INITIALIZATION
           PHI 3 	; PROGRAM WILL BE ASSEMBLED
           LDI (0B8h+7)
           PLO 2
           SEX 2
           LDI (0B8h+9) 	; START ASSEMBLING LBR INSTRUCTION
           STR 2
           GLO 0 	; ASSEMBLE LBR(R(P)) AS LAST OPCODE
           PLO HEXX
	; PLO HEXX ; incorrect duplicate HRJ jan 19 2014
           ANI 0Fh 	; -GET (P)
           SHL 	; -SET POINTER TO (R(P))
           ADD
           PLO 3
           LDN 3 	; -ASSEMBLE (R(P)) INTO INIT. PROGRAM
           STXD
           LDI 0A8h 	; -CANGE ORIGINAL (R(P)) TO POINT TO XX9E
           STR 3 	; SO EXECUTION CAN CONTINUE WHEN (P)=>P
           DEC 3
           LDN 3
           STXD
           GHI 2
           STR 3
           LDX 	; -RESTORE (Q) TO Q
           LSZ 	; IF (Q)=1,
           SEQ 	; THEN SET Q
           SKP 	; ELSE RESET Q
           REQ
           LDI 0C0h 	; -FINIS TEMPLATE LBR INSTRUCTION
           STXD
	; 
	; 
	; ASSEMBLE LDI OPCODE TO INITIALIZE (D)
	; 
	; 
           LDX 	; GET (IE) & SAVE FOR LATER
           PHI HEXX
           DEC 2 	; ASSMBLE LDI OPCODE TO INITIALIZE D
           LDXA
           STXD 	; -ASSEMBLE (D)
           LDI 0F8h 	; -ASSEMBLE LDI
           STXD
           LDX 	; RESTORE (DF) TO DF
           SHR
           LDI 0A2h 	; ASSEMBLE PLO R2 TO INITIALIZE R2.0
           STXD
           LDI (0B8h+13)
           PLO 3 	; -ASSEMBLE (R2.0)
           LDN 3
           STXD
           LDI 0F8h 	; -ASSEMBLE LDI
           STXD
	; 
	; 
	; NOW RESTORE ALL R'S EXCEPT R2 & R5.
	; 
	; 
           LDI (0B8h+8) 	; SET R2 TO (R0)
           PLO 2
           LDX 	; (R0)=>R0
           PHI 0
           GHI HEXX 	; GET (IE) & SAVE IN (R0.1)
           STR 2
           INC 2
           LDX
           PLO 0
           GLO HEXX 	; GET (XP) & SAVE IN (R0.0)
           STR 2
           INC 2
           LDXA 	; (R1)=>R1
           PHI 1
           LDXA
           PLO 1
           IRX 	; SKIP (R2)
           IRX
           LDXA 	; (R3)=>R3
           PHI 3
           LDXA
           PLO 3
           LDXA 	; (R4)=>R4
           PHI 4
           LDXA
           PLO 4
           IRX 	; SKIP (R5)
           IRX
           LDXA 	; (R6)=>R6
           PHI 6
           LDXA
           PLO 6
           LDXA 	; (R7)=>R7
           PHI 7
           LDXA
           PLO 7
           LDXA 	; (R8)=>R8
           PHI 8
           LDXA
           PLO 8
           LDXA 	; (R9)=>R9
           PHI 9
           LDXA
           PLO 9
           LDXA 	; (RA)=>RA
           PHI 10
           LDXA
           PLO 10
           LDXA 	; (RB)=>RB
           PHI 11
           LDXA
           PLO 11
           LDXA 	; (RC)=>RC
           PHI 12
           LDXA
           PLO 12
           LDXA 	; (RD)=>RD
           PHI 13
           LDXA
           PLO 13
           LDXA 	; (RE)=>RE
           PHI 14
           LDXA
           PLO 14
           LDXA 	; (RF)=>RF
           PHI 15
           LDX
           PLO 15
	; 
	; 
	; CHANGE PROGRAM COUNTER TO DESIRED REGISTER
	; 
           BR BRCHANGE 	; THIS IS LOCATION FOR A RELOCATABLE
	; "BR" TO PAGE WHERE THE PC IS LOCATED
	; 
	; BLOCK MOVE COMMAND (?MXXXX XX !MXXXX)
	; 
	; 
MOVE:      SEP 3  	;   GET NEXT KEY
           XRI 'M' 	; IF "M",
           BNZ ($+7) 	; THEN CLEAR HEXX
           PHI HEXX 	; ELSE SYNTAX ERROR
           PLO HEXX
           SEP 3 	; GET HEX ADDRESS OF DESTINATION
           BDF ($-1)
           XRI 0Dh 	; IF NOT <CR>,
           BNZ BRSYNERR 	; GO TO SYNTAX ERROR
	; 
	; 
	; TEST IF MOVE UP/MOVE DOWN (TRICKY WITHOUT RAM)
	; 
	; 
           GHI 0Ah 	; COPY SOURCE ADDRESS INTO R3
           PHI 3
           GLO 0Ah
           PLO 3
           GHI HEXX 	; COPY DESTINATION INTO RF
           PHI 0Fh
           GLO HEXX
           PLO 0Fh
UPDOWN:    GHI 3  	;   -IF SOURCE=0,
           BNZ ($+3) 	; SOURCE<DESTINATION; MOVE DATA UP
           GLO 3
           BZ MOVEUP
           DEC 3 	; DECREMENT SOURCE
           GHI 0Fh 	; -IF DESTINATON=0
           BNZ ($+3) 	; SOURCE>DESTINATION; MOVE DATA DOWN
           GLO 0Fh
           LSKP 	; SKIP TO CONTINUE
	; -------------------------
	; THE FOLLOWING LOCATION IS NEEDED FOR THE RELOCATABLE BRANCH TO THE
	; PC CHANGE ROUTINE, WHICH HAS BEEN MOVED TO THE SAME PAGE AS REGISTER
	; SAVE AREA.
	; 
BRCHANGE:  GHI 2  	;   GO TO PAGE THAT PROGRAM IS ON
           PHI 5
	; -------------------------
	; 
           DEC 0Fh 	; DECREMENT DESTINATION
           BNZ UPDOWN 	; DATA DOWN
	; 
	; 
	; SOURCE > DESTINATION: MOVE DATA DOWN
	; 
	; 
MOVEDN:    GHI 8  	;   REPEAT	; .
           BNZ ($+3) 	; 	; .UNTIL #BYTES=0
           GLO 8
           BZ BRRESTRT 	; THEN RESTART
           LDA 0Ah 	; -LOAD VIA SOURCE
           STR HEXX 	; -STORE VIA DESTINATION
           INC HEXX 	; -INCREMENT POINTERS
           DEC 8 	; -DECREMENT #BYTES
           BR MOVEDN
	; 
	; 
	; SOURCE <= DESTINATION: MOVE DATA UP.
	; 
	; 
MOVEUP:    GHI 8  	;   COPY #BYTES INTO R3
           PHI 3
           GLO 8
           PLO 3
           LSKP 	; SET POINTERS TO HIGH END OF DATA
UP:        INC 0Ah  	;   REPEAT	; .
           INC HEXX
           DEC 3 	; -INC. SOURCE
           GHI 3 	; -INC. DESTINATION
           BNZ UP 	; -DEC. #BYTES
           GLO 3
           BNZ UP 	; 	; .UNTIL #BYTES=0
           SEX HEXX 	; REPEAT TO MOVE FROM TOP DOWN	; .
MUP:       GHI 8  	;   	; .UNTIL #BYTES=0
           BNZ ($+3)
           GLO 8
           BZ BRRESTRT 	; THEN RESTART
           LDN 0Ah 	; -LOAD VIA SOURCE
           STXD 	; -STORE VIA DESTINATION
           DEC 0Ah 	; -DECREMENT POINTERS
           DEC 8
           BR MUP
	; 
	; 
	; THE FOLLOWING ROUTINE CHANGES THE PROGRAM COUNTER TO THE ONE DESIRED
	; IN A $R COMMAND. IT IS COPIED INTO RAM.
	; 
CHANGE:    LDI (0B8h+8)  	;   SET POINTER TO SAVED (IE)
           PLO 2
           LDXA 	; GET (IE)
           LSZ 	; IF (IE)=1,
           RET 	; THEN SET IE=1
           SKP 	; (P)=>P, (X)=>X
           DIS 	; ELSE SET IE=0
	; 
	; 
	; NOW SET UP R5 (IF NOT PC), R2, & D
	; 
RHERE:     INC 5  	;   IF R5 IS NOT THE PROGRAM COUNTER,
           LSKP 	; THIS WILL GIVE CORRECT "BR" ADDRESS
           BR (RESET+03B3h) 	; TO "R5PC" AFTER IT IS MOVED TO XXA0
           LDI (0B8h+18) 	; -SET POINTER TO (R5)
           PLO 2
           LDA 2 	; -(R5)=>R5
           PHI 5
           LDN 2
           PLO 5
R5PC:      LDI 0C4h  	;   -(R2.1)=>R2.1
           PLO 2
           LDN 2
           PHI 2
	; 
	; 
	; SAMPLE TEMPLATE PROGRAM CREATED IN RAM
	; 
	; ORG RESET+ 0XXB8H ;HRJ offset
	; LDI (R2.0) ; (R2.0)=>R2.0
	; PLO R2
	; LDI (D) ; (D)=>D
	; LBR (R(P)) ; GO TO USER PROGRAM
           ORG	(RESET+3F0h) 	; PAGE JUMPS: ALLOWS RELOCATABLE LONG BRANCH
	; ; TO PAGE 2.
	; 
BRSYNERR:  GHI 5  	;   BR TO SYNERR
           SMI 1
           PHI 5
BRRESTRT:  GHI 5  	;   BR TO RESTART
           SMI 1
           PHI 5
           ORG	(RESET+3FEh)
           BR MOVE
	; 
;	No END if included from another source file.
;	If used standalone, uncomment next line.
	   END
